import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

public class LGL {

    public static void main(String[] args) {
        loegraaf();
        Queue<Integer> jarjekord = new LinkedList<>();
        jarjekord.add(0); // lisame esimese tipu jrjekorda
        kaidud[0] = true; // see tipp on juba jrjekorras olemas

        while (!jarjekord.isEmpty()) {
            int tipp = jarjekord.remove();
            tootle(tipp);
            for (int i = 0; i < graaf[tipp].size(); i++) {
                int naaber = graaf[tipp].get(i); // iga naabertipu,
                if (!kaidud[naaber]) { // kus ei ole veel kinud,
                    jarjekord.add(naaber); // lisame jrjekorda
                    kaidud[naaber] = true;
                }
            }
        }
    }

    static int MAX_TIPPE = 100;
    static ArrayList<Integer>[] graaf = new ArrayList[MAX_TIPPE];
    static boolean[] kaidud = new boolean[MAX_TIPPE]; // alguses kik tipud on kimata
    static int tippude_arv;

    static void loegraaf() {
        Scanner scanner = new Scanner(System.in);
        tippude_arv = scanner.nextInt();
        int i, j;
        for (i = 0; i < tippude_arv; i++) {
            j = 1;
            String[] s = scanner.nextLine().split(" ");
            int tipp = Integer.parseInt(s[0]);
            while (j < s.length){
                int naaber = Integer.parseInt(s[j]);
                graaf[tipp - 1].add(naaber - 1);
            }
        }
    }

    static void tootle(int tipp)
    {
        System.out.print((tipp + 1) + " ");
    }
}
