import java.util.Scanner;
import java.util.Stack;

public class Ratsu1 {

    static int MAX_DIM = 8;
    static int dim, ruutude_arv;

    // massiiv, mis on abiks arvutamisel, kuhu ratsu kia saab (st naabertippude leidmiseks graafis)
    static int[][] deltad = {{-2, -1}, {-2, 1}, {2, -1}, {2, 1}, {1, 2}, {1, -2}, {-1, 2}, {-1, -2}};
    static boolean[][] kaidud = new boolean[MAX_DIM][MAX_DIM];
    static Stack vastus = new Stack();


    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        dim = scanner.nextInt();
        ruutude_arv = dim*dim;
        String algus;
        scanner.nextLine();
        algus = scanner.nextLine();
        if (Otsi(algus.charAt(0)-'a', algus.charAt(1)-'1', 1)) {
            while (vastus.size() > 0) {
                System.out.print(vastus.peek() + " ");
                vastus.pop();
            }
        }
        else
            System.out.println("EI SAA");

    }

    static boolean Otsi(int x, int y, int kaigu_nr)
    {
        if (kaigu_nr == ruutude_arv) return true; // kik ruudud on kidud, tee on leitud
        kaidud[x][y] = true; // siin me oleme

        for (int k = 0; k < 8; k++) { // iga vimaliku kigu jaoks
            int naaber_x = x + deltad[k][0];
            int naaber_y = y + deltad[k][1];
            if ((naaber_x < 0) || (naaber_x >= dim) || // kui on vljaspool..
                    (naaber_y < 0) || (naaber_y >= dim) || //..mngulauda
                    kaidud[naaber_x][naaber_y]) { // vi on juba kidud,
                continue; // pole sobiv sihtkoht, jtkame
            }
            if (Otsi(naaber_x, naaber_y, kaigu_nr + 1)) { // Proovime jrgmist kiku
                vastus.push("" + (char)(naaber_x + 'a') + (char)(naaber_y + '1'));
                return true;
            }
        }
        // ei leidnud teed, mis lbiks kik ruudud
        kaidud[x][y] = false; // vtame viimase kigu tagasi
        return false;
    }

}
