import java.util.Scanner;

public class Veekogud {

    static int[][] deltad =
    {{1, 0}, {1, 1}, {0, 1}, {-1, 1}, {-1, 0}, {-1, -1}, {0, -1}, {1, -1}};
    static int ridu, veerge;
    static char[][] kaart;

    static int taida(int r, int v, char v1, char v2) {
        if (r < 0 || r >= ridu || v < 0 || v >= veerge)  // Kui on vljaspool kaarti
            return 0;
        if (kaart[r][v] != v1) return 0; // kui ei ole esimest vrvi
        int vastus = 1; // lisab vastusele he
        kaart[r][v] = v2; // vrvime teist vrvi, et ei lheks tsklisse
        for (int d = 0; d < 8; d++) {
            vastus += taida(r + deltad[d][0], v + deltad[d][1], v1, v2);
        }
        return vastus;
    }


    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        ridu = scanner.nextInt();
        veerge = scanner.nextInt();
        kaart = new char[ridu][veerge];
        scanner.nextLine();
        for (int i = 0; i < ridu; i++) {
            String s = scanner.nextLine();
            for (int j = 0; j < veerge; j++) {
                kaart[i][j] = s.charAt(j);
            }
        }

        int veekogusid = 0;
        int suurim = 0;

        for (int i = 0; i < ridu; i++) {
            for (int j = 0; j < veerge; j++) {
                if (kaart[i][j] == 'S') {
                    veekogusid++;
                    suurim = Math.max(suurim, taida(i, j, 'S', '*'));
                }
            }
        }
        System.out.println(veekogusid);
        System.out.println(suurim);
    }
}
